/* ========================================================================= *
 *
 *                        MATH0471-A
 *            Projet de calcul scientifique multiphysique
 *            Domaine paramétrable pour résoudre l'équation d'onde.
 *
/* ========================================================================= *

/*-----------Parameters-----------------------------------*/

xposition[]={0,10,20};     //Division along x axis       
strate[]={0,-5,-10,-20,-30};     //Division along y axis 
Z=1;  

nx[]={30,30};               //Number of subdivisions along each division (x axis)
ny[]={1,2,3,4};                      //Number of subdivisions along each divison (y axis)
nz=2;                           //Number of subdivisions along z axis (for z>0)

objects[]={};                    //Number of the block associated with an object

/*---------------------------------------------------------*/

lengthxposition=#xposition[];
lengthstrate=#strate[];
nbobjects=#objects[];

For k In {0:lengthstrate-1}                                     //Point definition
  For  j In {1:lengthxposition}
    Point(k*lengthxposition+j)={xposition[j-1],strate[k],0,1.0}; 
EndFor
EndFor

For k In {0:lengthstrate-1}                                    //Horizontal line definition
  For  j In {1:lengthxposition-1}
    Line(k*(lengthxposition-1)+j)={k*lengthxposition+j,k*lengthxposition+j+1};
    Transfinite Line {k*(lengthxposition-1)+j}=nx[j-1]+1;
EndFor
EndFor

nbhorizontal = lengthstrate*(lengthxposition-1);

For k In {0:lengthstrate-2}                                    //Vertical line definition
  For  j In {1:lengthxposition}
    Line(nbhorizontal+k*lengthxposition+j)={k*lengthxposition+j,(k+1)*lengthxposition+j};
    Transfinite Line {nbhorizontal+k*lengthxposition+j}=ny[k]+1;
EndFor
EndFor


For k In {0:(lengthstrate-2)}                                 //Surface definition  + extrusion           
    For   j In {1:lengthxposition-1}
     stop=0;

     For  i In {0:nbobjects-1}
        If (k*(lengthxposition-1)+j == objects[i])
        stop=1;
        EndIf
     EndFor

     If(stop !=1)
     Line Loop(k*(lengthxposition-1)+j)={k*(lengthxposition-1)+j,nbhorizontal+k*lengthxposition+j+1,-((k+1)*(lengthxposition-1)+j),
     -(nbhorizontal+k*lengthxposition+j)};
     Plane Surface(k*(lengthxposition-1)+j)={k*(lengthxposition-1)+j};
     Transfinite Surface{k*(lengthxposition-1)+j};
     Recombine Surface{k*(lengthxposition-1)+j};

     Extrude {0, 0, Z} {
     Surface{k*(lengthxposition-1)+j}; Layers{nz}; Recombine;
                        }
      Extrude {0, 0, -Z} {
      Surface{k*(lengthxposition-1)+j}; Layers{nz}; Recombine;
                          }
     EndIf
    
     EndFor
EndFor


